<!DOCTYPE html>
<html>

<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

  <script>
    "use strict";

    // Định nghĩa các mảng students, subjects và grades

    // Điền dữ liệu mẫu cho đối tượng sinh viên
    var gStudents = [
      {
        id: 2, // tự tăng
        studentCode: "1356783",
        firstname: "Ngo Van",
        lastname: "Quan",
        age: 18,
        email: "quan@gmail.com",
        studyYear: 2015
      },
      {
        id: 3, // tự tăng
        studentCode: "2468101",
        firstname: "Nguyen Thi",
        lastname: "Hoa",
        age: 19,
        email: "hoa@gmail.com",
        studyYear: 2016
      },
      {
        id: 4, // tự tăng
        studentCode: "3579112",
        firstname: "Tran Van",
        lastname: "Nam",
        age: 20,
        email: "nam@gmail.com",
        studyYear: 2017
      },
      {
        id: 5, // tự tăng
        studentCode: "4681013",
        firstname: "Le Thi",
        lastname: "Mai",
        age: 21,
        email: "mai@gmail.com",
        studyYear: 2018
      },
      {
        id: 6, // tự tăng
        studentCode: "5791124",
        firstname: "Pham Van",
        lastname: "Long",
        age: 22,
        email: "long@gmail.com",
        studyYear: 2019
      }
    ];

    // Điền dữ liệu mẫu cho đối tượng môn học
    var gSubjects = [
      {
        id: 5, // tự tăng
        subjectCode: "MATH101",
        subjectName: "Toán cao cấp 1"
      },
      {
        id: 6, // tự tăng
        subjectCode: "PHYS102",
        subjectName: "Vật lý đại cương 2"
      },
      {
        id: 7, // tự tăng
        subjectCode: "CHEM103",
        subjectName: "Hóa học hữu cơ"
      },
      {
        id: 8, // tự tăng
        subjectCode: "BIO104",
        subjectName: "Sinh học phân tử"
      },
      {
        id: 9, // tự tăng
        subjectCode: "COMP105",
        subjectName: "Lập trình căn bản"
      }
    ];

    // Điền dữ liệu mẫu cho đối tượng điểm
    var gGrades = [
      {
        id: 2,
        studentId: 2,
        subjectId: 5,
        grade: 8,
        examDate: "13/04/2021"
      },
      {
        id: 3,
        studentId: 3,
        subjectId: 6,
        grade: 7,
        examDate: "15/04/2021"
      },
      {
        id: 4,
        studentId: 4,
        subjectId: 7,
        grade: 9,
        examDate: "17/04/2021"
      },
      {
        id: 5,
        studentId: 5,
        subjectId: 8,
        grade: 6,
        examDate: "19/04/2021"
      },
      {
        id: 6,
        studentId: 6,
        subjectId: 9,
        grade: 8.5,
        examDate: "21/04/2021"
      },
      // Thêm 9 kết quả thi nữa
    ];

    $(document).ready(function () {
      // Tạo DataTable từ bảng user-table
      var table = $('#user-table').DataTable({
        // Thiết lập các cột dữ liệu
        columns: [
          { data: 'id' },
          { data: 'student' },
          { data: 'subject' },
          { data: 'grade' },
          { data: 'examDate' }
        ],
        // Thiết lập nguồn dữ liệu
        data: gGrades,
        // Thiết lập hiển thị số bản ghi trên mỗi trang
        pageLength: 10,
        // Thiết lập ngôn ngữ DataTable
        language: {
          url: "https://cdn.datatables.net/plug-ins/1.10.24/i18n/Vietnamese.json"
        }
      });

      // Điền dữ liệu cho ô select Student
      var studentSelect = $('#studentSelect');
      gStudents.forEach(function (student) {
        studentSelect.append('<option value="' + student.id + '">' + student.firstname + ' ' + student.lastname + '</option>');
      });

      // Điền dữ liệu cho ô select Subject
      var subjectSelect = $('#subjectSelect');
      gSubjects.forEach(function (subject) {
        subjectSelect.append('<option value="' + subject.id + '">' + subject.subjectName + '</option>');
      });

      // Xử lý sự kiện khi nhấn nút Lọc dữ liệu
      $('#btn-filter-role').click(function () {
        var selectedStudentId = parseInt(studentSelect.val());
        var selectedSubjectId = parseInt(subjectSelect.val());

        // Lọc dữ liệu theo sinh viên và môn học đã chọn
        var filteredGrades = gGrades.filter(function (grade) {
          return (selectedStudentId === 0 || grade.studentId === selectedStudentId) &&
            (selectedSubjectId === 0 || grade.subjectId === selectedSubjectId);
        });

        // Cập nhật dữ liệu trong DataTable
        table.clear().rows.add(filteredGrades).draw();
      });
    });
  </script>
</head>

<body>
  <div class="container">
    <div class="form-group">
      <pre>
        - Định nghĩa 03 đối tượng students (sinh viên), subjects (môn học) và grades (bảng điểm)
        - Điền dữ liệu mẫu cho 03 đối tượng trên. 
            + Student điền 5 sinh viên
            + Subject điền 5 môn học
            + Grades: điền 10 kết quả học tập cho các sinh viên và môn học ở trên
        - Thực hiện load dữ liệu bảng điểm (grades)
        - Thêm bộ lọc theo 2 ô select: Student và Subject
      </pre>
    </div>
  </div>
  <div class="container">
    <div class="text-center mt-4 mb-3">
      <h2>F200 - LỊCH SỬ HỌC TẬP</h2>
    </div>
    <div class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-1">
          <label for="studentSelect">Student</label>
        </div>
        <div class="col-sm-3">
          <select id="studentSelect" class="form-control">
            <option value="0">All</option>
          </select>
        </div>
        <div class="col-sm-1">
          <label for="subjectSelect">Subject</label>
        </div>
        <div class="col-sm-3">
          <select id="subjectSelect" class="form-control">
            <option value="0">All</option>
          </select>
        </div>
        <div class="col-sm-4">
          <button id="btn-filter-role" class="btn btn-primary">Lọc dữ liệu</button>
        </div>
      </div>
      <table id="user-table" class="table table-striped table-bordered">
        <thead>
          <tr>
            <th>ID</th>
            <th>Student</th>
            <th>Subject</th>
            <th>Grade</th>
            <th>Exam Date</th>
          </tr>
        </thead>
      </table>
    </div>
  </div>
</body>

</html>